/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010-2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_functions_adduser
#define headerfile_winix_functions_adduser

#include "functionbase.h"
#include "core/user.h"


namespace Fun
{


class AddUser : public FunctionBase
{
public:

	AddUser();
	void MakePost();
	void MakeGet();

	bool IsLoginCorrect(const std::wstring & login, bool use_ses_log = false);
	bool IsEmailCorrect(const std::wstring & email, bool use_ses_log = false);

	bool HasLoginCorrectChars(const std::wstring & login);
	bool AddNewUser(User & user, const std::wstring & pass);

private:

	UserPass up;
	User user;

};


} // namespace

#endif
