/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "templates.h"
#include "../core/lastcontainer.h"
#include "../core/request.h"
#include "../core/misc.h"




namespace TemplatesFunctions
{
static size_t last_reqid = 0;
static LastContainer::Iterator last_iterator;


bool last_init()
{
	if( last_reqid != cur->request->id )
	{
		last_reqid    = cur->request->id;	
		last_iterator = system->users.last.Begin();
	}
	
	return last_iterator != system->users.last.End();
}



void last_tab(Info & i)
{
	last_init();

	if( i.iter != 0 && last_iterator != system->users.last.End() )
		++last_iterator;
		
	i.res = last_iterator != system->users.last.End();
}


void last_tab_name(Info & i)
{
	if( !last_init() )
		return;
	
	i.out << last_iterator->name;
}


void last_tab_ip(Info & i)
{
	if( !last_init() )
		return;
	
	i.out << IpToStr(last_iterator->ip);
}


void last_tab_start(Info & i)
{
	if( !last_init() )
		return;
	
	i.out << DateToStr(&last_iterator->start);
}


void last_tab_end(Info & i)
{
	if( !last_init() )
		return;
	
	if( last_iterator->IsLoggedOut() )
		i.out << DateToStr(&last_iterator->end);
}


} // namespace TemplatesFunctions



